/*
 *  Copyright 2016 http://www.hswebframework.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 *
 */

package org.hswebframework.web.service.dictionary;

import java.io.Serializable;
import java.util.List;
import java.util.Optional;

/**
 * 字典解析器接口
 *
 * @author zhouhao
 */
public interface DictionaryParser<V> extends Serializable {

    Optional<V> textToValue(String text, Object context);

    Optional<String> valueToText(V value, Object context);

    default Optional<V> textToValue(String text) {
        return textToValue(text, null);
    }

    default Optional<String> valueToText(V value) {
        return valueToText(value, null);
    }

}
